unit U_YarnOutList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxGridCustomTableView, cxGridTableView,
  cxGridBandedTableView, cxGridDBBandedTableView, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridDBTableView, cxGrid, StdCtrls, ComCtrls,
  ExtCtrls, ToolWin, cxGridCustomPopupMenu, cxGridPopupMenu, ADODB, DBClient,
  cxDropDownEdit, cxCheckBox, RM_Common, RM_Class, RM_e_Xls, RM_Dataset,
  RM_System, RM_GridReport, Menus, cxCalendar, cxButtonEdit, cxTextEdit, cxPC,
  cxLookAndFeels, cxLookAndFeelPainters, dxSkinsCore, dxSkinsDefaultPainters,
  cxNavigator, dxDateRanges, dxBarBuiltInMenu, U_BaseList;

type
  TfrmYarnOutList = class(TfrmBaseList)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBExport: TToolButton;
    TBClose: TToolButton;
    Panel1: TPanel;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DataSource1: TDataSource;
    cxGridPopupMenu1: TcxGridPopupMenu;
    Label1: TLabel;
    Label2: TLabel;
    BegDate: TDateTimePicker;
    EndDate: TDateTimePicker;
    CDS_Main: TClientDataSet;
    RM1: TRMGridReport;
    RMDBMain: TRMDBDataSet;
    RMXLSExport1: TRMXLSExport;
    RMDBHZ: TRMDBDataSet;
    CDS_HZ: TClientDataSet;
    CDS_PRT: TClientDataSet;
    TBDel: TToolButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    TBAdd: TToolButton;
    TBEdit: TToolButton;
    cxGrid2: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column6: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    v1Column4: TcxGridDBColumn;
    v1Column15: TcxGridDBColumn;
    v1Column14: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v1Column8: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    v1Column12: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    Label3: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    Label12: TLabel;
    Y_Name: TEdit;
    BYIOID: TEdit;
    Y_spec: TEdit;
    IOType: TComboBox;
    v1Column1: TcxGridDBColumn;
    v1Column10: TcxGridDBColumn;
    v1Column17: TcxGridDBColumn;
    v1Column7: TcxGridDBColumn;
    v1Column16: TcxGridDBColumn;
    ToolButton1: TToolButton;
    Tv1Column1: TcxGridDBColumn;
    Tv1Column2: TcxGridDBColumn;
    Tv1Column3: TcxGridDBColumn;
    Tv1Column4: TcxGridDBColumn;
    Tv1Column5: TcxGridDBColumn;
    Tv1Column6: TcxGridDBColumn;
    Tv1Column7: TcxGridDBColumn;
    Tv1Column8: TcxGridDBColumn;
    Tv1Column9: TcxGridDBColumn;
    Tv1Column10: TcxGridDBColumn;
    Tv1Column11: TcxGridDBColumn;
    Tv1Column12: TcxGridDBColumn;
    Tv1Column13: TcxGridDBColumn;
    Tv1Column14: TcxGridDBColumn;
    Label4: TLabel;
    Label6: TLabel;
    ToOrdNo: TEdit;
    C_Name: TEdit;
    Label7: TLabel;
    Filler: TEdit;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ConNoMChange(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure SPNameChange(Sender: TObject);
    procedure BYIOIDChange(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBAddClick(Sender: TObject);
    procedure TBEditClick(Sender: TObject);
    procedure Y_specChange(Sender: TObject);
    procedure cxTabControl1Change(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
  private
    canshu1, FStkName, canshu3: string;
    procedure InitGrid();
    { Private declarations }
  public

    { Public declarations }
  end;

implementation

uses
  U_DataLink, U_RTFun, U_YarnOutEdit;

{$R *.dfm}

procedure TfrmYarnOutList.FormDestroy(Sender: TObject);
begin
  inherited;  //frmPBOutList:=nil;
end;

procedure TfrmYarnOutList.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  Action := caFree;
end;

procedure TfrmYarnOutList.FormCreate(Sender: TObject);
begin
  inherited;
  canshu1 := Trim(self.fParameters1);
  FStkName := Trim(self.fParameters2);
  canshu3 := Trim(self.fParameters3);
  EndDate.DateTime := SGetServerDate(ADOQueryTemp);
  BegDate.DateTime := EndDate.DateTime - 90;
end;

procedure TfrmYarnOutList.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      sql.Clear;
      sql.Add(' select A.* ');
      sql.Add(' ,C_Name=(select C_Name from Knit_Plan_Sub X where X.MainID =A.ToMainId ) ');
      sql.Add(' from BS_Yarn_IO A');
      sql.add(' where A.IOTime>=''' + Trim(FormatDateTime('yyyy-MM-dd', BegDate.DateTime)) + '''');
      sql.Add(' and A.IOTime<''' + Trim(FormatDateTime('yyyy-MM-dd', enddate.DateTime + 1)) + '''');
      sql.Add(' and isnull(stkName,'''')=''' + Trim(FstkName) + '''');
      SQL.Add(' and ioFlag=''出库''  ');
//      if cxTabControl1.TabIndex = 0 then
//      begin
//        Sql.Add(' and ZFFlag=0 ');
//      end
//      else if cxTabControl1.TabIndex = 1 then
//      begin
//        Sql.Add(' and ZFFlag=1 ');
//      end;
//      ShowMessage (sql.TEXT)  ;
      Open;
    end;
    SCreateCDS(ADOQueryMain, CDS_Main);
    SInitCDSData(ADOQueryMain, CDS_Main);
  finally
    ADOQueryMain.EnableControls;
  end;
end;

procedure TfrmYarnOutList.TBRafreshClick(Sender: TObject);
begin
  BegDate.SetFocus;
  InitGrid();
end;

procedure TfrmYarnOutList.ToolButton1Click(Sender: TObject);
begin
  WriteCxGrid(trim(Self.Caption), Tv1, '染色坯布仓库');

end;

procedure TfrmYarnOutList.ConNoMChange(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
  end;
end;

procedure TfrmYarnOutList.TBCloseClick(Sender: TObject);
begin

  Close;
end;

procedure TfrmYarnOutList.FormShow(Sender: TObject);
begin
  inherited;
  ReadCxGrid(trim(Self.Caption), Tv1, '染色坯布仓库');
  if canshu1 = '管理' then
  begin
    TBAdd.Visible := true;
    TBEdit.Visible := true;
    TBDel.Visible := true;
  end
  else
  begin
    TBAdd.Visible := false;
    TBEdit.Visible := false;
    TBDel.Visible := false;
  end;
  InitGrid();
end;

procedure TfrmYarnOutList.TBExportClick(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then
    exit;
  TcxGridToExcel(FstkName + '出库列表', cxGrid2);
end;

procedure TfrmYarnOutList.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
    SCreateCDS(ADOQueryMain, CDS_Main);
    SInitCDSData(ADOQueryMain, CDS_Main);
  end;
end;

procedure TfrmYarnOutList.SPNameChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmYarnOutList.BYIOIDChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmYarnOutList.N1Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, True);
end;

procedure TfrmYarnOutList.N2Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, False);
end;

procedure TfrmYarnOutList.TBDelClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;

  with ADOQueryCmd do
  begin
    Close;
    Sql.Clear;
    sql.Add('select * from Finance_Flow where Status=''9'' and FromID1=' + quotedstr(Trim(CDS_Main.fieldbyname('BYIOID').AsString)) + '');
    open;
  end;

  if ADOQueryCmd.IsEmpty = false then
  begin
    Application.MessageBox('财务已审核，无法删除!', '提示', 0);
    Exit;
  end;

  if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
    Exit;

  try
    ADOQueryCmd.Connection.BeginTrans;
    with ADOQueryCmd do
    begin
      Close;
      Sql.Clear;
      Sql.Add('exec P_BS_Yarn_Out_Del ');
      Sql.Add(' @BYIOIDS=' + quotedstr(Trim(CDS_Main.fieldbyname('BYIOID').AsString)));
      Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
      Sql.Add(',@DName=' + quotedstr(Trim(DName)));
      Open;
    end;
    if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
      raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));

    with ADOQueryTemp do
    begin
      Close;
      Sql.Clear;
      sql.Add('insert into Finance_Need_Up(UType,UDataId) values(''纱线出库'',' + quotedstr(Trim(CDS_Main.fieldbyname('BYIOID').AsString)) + ')  ');
      ExecSQL;
    end;

    ADOQueryCmd.Connection.CommitTrans;
    CDS_Main.Delete;
  except
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
  end;

end;

procedure TfrmYarnOutList.TBAddClick(Sender: TObject);
begin
  try
    frmYarnOutEdit := TfrmYarnOutEdit.Create(Application);
    with frmYarnOutEdit do
    begin
      FBCId := '';
      FstkName := Self.FstkName;
      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmYarnOutEdit.Free;
  end;
end;

procedure TfrmYarnOutList.TBEditClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;

  with ADOQueryCmd do
  begin
    Close;
    Sql.Clear;
    sql.Add('select * from Finance_Flow where Status=''9'' and FromID1=' + quotedstr(Trim(CDS_Main.fieldbyname('BYIOID').AsString)) + '');
    open;
  end;

  if ADOQueryCmd.IsEmpty = false then
  begin
    Application.MessageBox('财务已审核，无法修改!', '提示', 0);
    Exit;
  end;

  with ADOQueryTemp do
  begin
    Close;
    Sql.Clear;
    sql.Add('insert into Finance_Need_Up(UType,UDataId) values(''纱线出库'',' + quotedstr(Trim(CDS_Main.fieldbyname('BYIOID').AsString)) + ')  ');

    Sql.Add('exec P_BS_Yarn_Out_Edit ');
    Sql.Add(' @BYIOIDS=' + quotedstr(Trim(CDS_Main.fieldbyname('BYIOID').AsString)));
    Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
    Sql.Add(',@DName=' + quotedstr(Trim(DName)));
//    ShowMessage(sql.Text);
    Open;
  end;
  if ADOQueryTemp.FieldByName('intReturn').AsInteger = -1 then
  begin
    Application.MessageBox(PChar(ADOQueryTemp.fieldbyname('ShowMsg').AsString), '提示', 0);
    exit;
  end;
  with ADOQueryTemp do
  begin
    Close;
    Sql.Clear;
    sql.Add('insert into Finance_Need_Up(UType,UDataId) values(''纱线出库'',' + quotedstr(Trim(CDS_Main.fieldbyname('BYIOID').AsString)) + ')  ');
    ExecSQL;
  end;

  try
    frmYarnOutEdit := TfrmYarnOutEdit.Create(Application);
    with frmYarnOutEdit do
    begin
      FBCId := Trim(CDS_Main.fieldbyname('BYIOID').AsString);
      TBDel.Visible := False;
      TBAdd.Visible := False;
      FstkName := Self.FstkName;
      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmYarnOutEdit.Free;
  end;

end;

procedure TfrmYarnOutList.Y_specChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmYarnOutList.cxTabControl1Change(Sender: TObject);
begin
  InitGrid();
end;

end.

